// DialogExport.cpp : implementation file
//

#include "stdafx.h"
#include "GV.h"
#include "DialogExport.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogExport dialog


CDialogExport::CDialogExport(GenomePage& m_gp)
	: CDialog(CDialogExport::IDD, NULL)
{
	// Save a pointer to the genome page
	ptr_gp = &m_gp;

	export_format = GenomePage::EXPORT_GBK;

	//{{AFX_DATA_INIT(CDialogExport)
	m_cds = TRUE;
	m_gene = TRUE;
	m_intergenic = FALSE;
	m_misc = TRUE;
	m_primer = TRUE;
	m_pseudo = TRUE;
	m_rna = TRUE;
	m_trna = TRUE;
	m_user = TRUE;
	//}}AFX_DATA_INIT
}


void CDialogExport::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogExport)
	DDX_Check(pDX, IDC_CHECK_CDS, m_cds);
	DDX_Check(pDX, IDC_CHECK_GENE, m_gene);
	DDX_Check(pDX, IDC_CHECK_INTERGENIC, m_intergenic);
	DDX_Check(pDX, IDC_CHECK_MISC, m_misc);
	DDX_Check(pDX, IDC_CHECK_PRIMER, m_primer);
	DDX_Check(pDX, IDC_CHECK_PSEUDO, m_pseudo);
	DDX_Check(pDX, IDC_CHECK_RNA, m_rna);
	DDX_Check(pDX, IDC_CHECK_tRNA, m_trna);
	DDX_Check(pDX, IDC_CHECK_USER, m_user);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogExport, CDialog)
	//{{AFX_MSG_MAP(CDialogExport)
	ON_BN_CLICKED(IDC_RADIO_FASTA_DNA, OnRadioFastaDna)
	ON_BN_CLICKED(IDC_RADIO_FASTA_GENOME, OnRadioFastaGenome)
	ON_BN_CLICKED(IDC_RADIO_FASTA_PROTEIN, OnRadioFastaProtein)
	ON_BN_CLICKED(IDC_RADIO_GBK, OnRadioGbk)
	ON_BN_CLICKED(IDC_RADIO_PTT, OnRadioPtt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogExport message handlers

void CDialogExport::OnRadioFastaDna() 
{
	// Active all annotations and uncheck intergenic space
	GetDlgItem(IDC_CHECK_GENE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PSEUDO)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_CDS)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_RNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_tRNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_MISC)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PRIMER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_INTERGENIC)->EnableWindow(TRUE);

	m_intergenic = false;

	export_format = GenomePage::EXPORT_FASTA_DNA;

	UpdateData(FALSE);
}

void CDialogExport::OnRadioFastaGenome() 
{
	// Deactive all annotations and turn on all annotations except intergenic space
	GetDlgItem(IDC_CHECK_GENE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_PSEUDO)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_CDS)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_RNA)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_tRNA)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_MISC)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_PRIMER)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_USER)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_INTERGENIC)->EnableWindow(FALSE);

	m_gene = true;
	m_intergenic = false;
	m_misc = true;
	m_primer = true;
	m_pseudo = true;
	m_rna = true;
	m_trna = true;
	m_user = true;
	
	export_format = GenomePage::EXPORT_FASTA_GENOME;

	UpdateData(FALSE);
}

void CDialogExport::OnRadioFastaProtein() 
{
	// Active all annotations and uncheck all non-amino acid annotations
	GetDlgItem(IDC_CHECK_GENE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PSEUDO)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_CDS)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_RNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_tRNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_MISC)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PRIMER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_INTERGENIC)->EnableWindow(TRUE);

	m_intergenic = false;
	m_pseudo = false;
	m_misc = false;
	m_primer = false;
	m_rna = false;
	m_trna = false;
	m_user = false;

	export_format = GenomePage::EXPORT_FASTA_PROTEIN;

	UpdateData(FALSE);
}

void CDialogExport::OnRadioGbk() 
{
	// Active all annotations and uncheck intergenic space
	GetDlgItem(IDC_CHECK_GENE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PSEUDO)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_CDS)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_RNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_tRNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_MISC)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PRIMER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_INTERGENIC)->EnableWindow(TRUE);

	m_intergenic = false;

	export_format = GenomePage::EXPORT_GBK;

	UpdateData(FALSE);
}

void CDialogExport::OnRadioPtt() 
{
	// Active all annotations and uncheck intergenic space
	GetDlgItem(IDC_CHECK_GENE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PSEUDO)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_CDS)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_RNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_tRNA)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_MISC)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_PRIMER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USER)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_INTERGENIC)->EnableWindow(TRUE);

	m_intergenic = false;

	export_format = GenomePage::EXPORT_PTT;

	UpdateData(FALSE);
}

void CDialogExport::OnOK() 
{
	if(ptr_gp == NULL){
		throw "Invalid ptr_gp";
	}

	// Validate the users input
	ptr_gp->clear_annotations_to_export();

	if(m_cds){
		ptr_gp->add_annotation_to_export(GeneAnnotation::CDS);
	}

	if(m_gene){
		ptr_gp->add_annotation_to_export(GeneAnnotation::GENE);
	}

	if(m_intergenic){
		ptr_gp->add_annotation_to_export(GeneAnnotation::NONE);
	}

	if(m_misc){
		ptr_gp->add_annotation_to_export(GeneAnnotation::IMP);
	}

	if(m_primer){
		ptr_gp->add_annotation_to_export(GeneAnnotation::PRIMER);
	}

	if(m_pseudo){
		ptr_gp->add_annotation_to_export(GeneAnnotation::PSEUDO_GENE);
	}

	if(m_rna){
		ptr_gp->add_annotation_to_export(GeneAnnotation::RNA);
	}

	if(m_trna){
		ptr_gp->add_annotation_to_export(GeneAnnotation::tRNA);
	}

	if(m_user){
		ptr_gp->add_annotation_to_export(GeneAnnotation::USER);
	}

	if(ptr_gp->num_annotations_to_export() == 0){
		AfxMessageBox("Please specify at least one annotation type to export");
		return;
	}

	if(ptr_gp->set_export_format(export_format) == false){
		AfxMessageBox("Please specify a valid export format (PTT only allows a single genome)");
		return;
	}

	// Get a file name
	CFileDialog fDlg(FALSE); // Save as ...

	fDlg.m_ofn.lpstrTitle = "Export genome(s)";

	switch(export_format){
		case GenomePage::EXPORT_FASTA_DNA:
			fDlg.m_ofn.lpstrFilter = "Fasta file\0*.ffn\0All Files\0*.*\0\0";
			break;
		case GenomePage::EXPORT_FASTA_GENOME:
			fDlg.m_ofn.lpstrFilter = "Fasta file\0*.fna\0All Files\0*.*\0\0";
			break;
		case GenomePage::EXPORT_FASTA_PROTEIN:
			fDlg.m_ofn.lpstrFilter = "Fasta file\0*.faa\0All Files\0*.*\0\0";
			break;
		case GenomePage::EXPORT_GBK:
			fDlg.m_ofn.lpstrFilter = "GBK file\0*.gbk\0All Files\0*.*\0\0";
			break;
		case GenomePage::EXPORT_PTT:
			fDlg.m_ofn.lpstrFilter = "PTT file\0*.ptt\0All Files\0*.*\0\0";
			break;
		default:
			fDlg.m_ofn.lpstrFilter = "All Files\0*.*\0\0";
			break;
	};

	if(fDlg.DoModal() == IDOK){
		HCURSOR prevCursor = ::SetCursor( LoadCursor(NULL, IDC_WAIT) );

		try{
			ptr_gp->export_genomes( LPCSTR( fDlg.GetFileName() ) );

			::SetCursor(prevCursor);
		}
		catch(const char *error){
			
			::SetCursor(prevCursor);
			AfxMessageBox(error);
		}
		catch(...){

			::SetCursor(prevCursor);
			AfxMessageBox("An export error has occured");
		}
	}
}

BOOL CDialogExport::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CheckRadioButton(IDC_RADIO_FASTA_GENOME,		// First button
				 IDC_RADIO_PTT,	// Last bottom	
				 IDC_RADIO_GBK);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
