// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#if !defined(AFX_HYBRIDDIALOG_H__38A9F256_A832_418E_A4A4_116D6D893D5E__INCLUDED_)
#define AFX_HYBRIDDIALOG_H__38A9F256_A832_418E_A4A4_116D6D893D5E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HybridDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHybridDialog dialog

#define		WM_HYBRID_CLOSE		(WM_USER + 14)
#define		WM_HYBRID_NEXT		(WM_USER + 15)
#define		WM_HYBRID_PRIMER	(WM_USER + 16)
#define		WM_HYBRID_PROBE		(WM_USER + 17)
#define		WM_HYBRID_ANNOTATE	(WM_USER + 18)

class CHybridDialog : public CDialog
{
// Construction
public:
	CHybridDialog(CView* pParent);
	
	BOOL Create();
	BOOL OnInitDialog();

	CView *m_pView;

// Dialog Data
	//{{AFX_DATA(CHybridDialog)
	enum { IDD = IDD_HYBRID_DIALOG };
	float	m_salt;
	float	m_strand;
	float	m_tm;
	CString	m_primer1;
	CString	m_primer2;
	CString	m_probe;
	UINT	m_anchor;
	CString	m_results;
	int		m_max_amplicon_length;
	int		m_min_amplicon_length;
	//}}AFX_DATA

	inline CString probe_string() const
	{
		return m_probe;
	};

	inline CString primer1_string() const
	{
		return m_primer1;
	};

	inline CString primer2_string() const
	{
		return m_primer2;
	};

	inline float tm() const
	{
		return m_tm;
	};

	inline float salt() const
	{
		return m_salt;
	};

	inline float strand() const
	{
		return m_strand;
	};

	inline unsigned int anchor() const
	{
		return m_anchor;
	};

	inline unsigned int max_amplicon_length() const
	{
		return m_max_amplicon_length;
	};
	
	inline unsigned int min_amplicon_length() const
	{
		return m_min_amplicon_length;
	};

	inline void results_string(const std::string &m_results_string)
	{
		m_results = m_results_string.c_str();
		
		UpdateData(FALSE);
	};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHybridDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CHybridDialog)
	afx_msg void OnCloseHybrid();
	afx_msg void OnPrimerButton();
	afx_msg void OnNextHybridButton();
	afx_msg void OnProbeButton();
	afx_msg void OnAnnotateHybridButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HYBRIDDIALOG_H__38A9F256_A832_418E_A4A4_116D6D893D5E__INCLUDED_)
