// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

// InfoDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GV.h"
#include "InfoDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInfoDialog dialog


CInfoDialog::CInfoDialog(CView* pParent)
	: CDialog(CInfoDialog::IDD, pParent)
{
	m_pView = pParent;

	//{{AFX_DATA_INIT(CInfoDialog)
	m_info = _T("");
	//}}AFX_DATA_INIT
}


void CInfoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoDialog)
	DDX_Text(pDX, IDC_INFO_RICHEDIT, m_info);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInfoDialog, CDialog)
	//{{AFX_MSG_MAP(CInfoDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInfoDialog message handlers
BOOL CInfoDialog::Create() 
{
	return CDialog::Create(CInfoDialog::IDD);
}

BOOL CInfoDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CInfoDialog::OnCancel() 
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_INFO_CLOSE, 0);
	}
}


void CInfoDialog::info_text(const std::string &m_info_text)
{
	m_info = m_info_text.c_str();

	UpdateData(FALSE);
}
