// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "GV.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,			// Base location
	ID_SEPARATOR			// Info
	//ID_SEPARATOR,         // Tm location
	//ID_SEPARATOR,         // %GC location
	//ID_SEPARATOR          // Genome Plot location
	//ID_INDICATOR_CAPS,
	//ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
#ifdef USE_TOOL_BAR
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
#endif // USE_TOOL_BAR

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Base coordinate
	//m_wndStatusBar.SetPaneInfo(BASE_PANE, m_wndStatusBar.GetItemID(BASE_PANE),
	//	SBPS_NORMAL, 50);

	// Tm coordinate
	//m_wndStatusBar.SetPaneInfo(TM_PANE, m_wndStatusBar.GetItemID(TM_PANE),
	//	SBPS_NORMAL, 75);

	// %GC coordinate
	//m_wndStatusBar.SetPaneInfo(GC_PANE, m_wndStatusBar.GetItemID(GC_PANE),
	//	SBPS_NORMAL, 75);

	// Genome Plot coordinate
	//m_wndStatusBar.SetPaneInfo(PLOT_PANE, m_wndStatusBar.GetItemID(PLOT_PANE),
	//	SBPS_NORMAL, 75);

	// Plot values
	m_wndStatusBar.SetPaneInfo(PLOT_PANE, m_wndStatusBar.GetItemID(PLOT_PANE),
	SBPS_NORMAL, 500);

	// General info
	m_wndStatusBar.SetPaneInfo(INFO_PANE, m_wndStatusBar.GetItemID(INFO_PANE),
		SBPS_STRETCH, 0);


#ifdef USE_TOOL_BAR
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
#endif // USE_TOOL_BAR

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
