// MolPCRHybridDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GV.h"
#include "MolPCRHybridDialog.h"
#include "nuc_cruc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MolPCRHybridDialog dialog


MolPCRHybridDialog::MolPCRHybridDialog(CView* pParent)
	: CDialog(MolPCRHybridDialog::IDD, pParent)
{
	m_pView = pParent;

	//{{AFX_DATA_INIT(MolPCRHybridDialog)
	m_salt = NC_Na;
	m_strand = NC_CT;
	m_tm = 50.0f;
	m_primer1 = _T("");
	m_primer2 = _T("");
	m_results = _T("");
	m_exact_match = 3;
	//}}AFX_DATA_INIT
}


void MolPCRHybridDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MolPCRHybridDialog)
	DDX_Text(pDX, IDC_SALT_EDIT, m_salt);
	DDX_Text(pDX, IDC_STRAND_EDIT, m_strand);
	DDX_Text(pDX, IDC_TM_EDIT, m_tm);
	DDX_Text(pDX, IDC_PRIMER1_EDIT, m_primer1);
	DDX_Text(pDX, IDC_PRIMER2_EDIT, m_primer2);
	DDX_Text(pDX, IDC_HYBRID_RESULTS_RICHEDIT, m_results);
	DDX_Text(pDX, IDC_EXACT_EDIT, m_exact_match);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MolPCRHybridDialog, CDialog)
	//{{AFX_MSG_MAP(MolPCRHybridDialog)
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, OnCloseHybrid)
	ON_BN_CLICKED(ID_PRIMER_BUTTON, OnPrimerButton)
	ON_BN_CLICKED(IDC_NEXT_HYBRID_BUTTON, OnNextHybridButton)
	ON_BN_CLICKED(IDC_ANNOTATE_HYBRID_BUTTON, OnAnnotateHybridButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MolPCRHybridDialog message handlers
BOOL MolPCRHybridDialog::Create() 
{
	return CDialog::Create(MolPCRHybridDialog::IDD);
}

BOOL MolPCRHybridDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void MolPCRHybridDialog::OnCloseHybrid() 
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_HYBRID_MOL_PCR_CLOSE, 0);
	}
}

void MolPCRHybridDialog::OnPrimerButton() 
{
	// Only attempt to hybridize if all variables pass the
	// dialog's automatic validation step
	if( UpdateData(TRUE) && (m_pView != NULL) ){
		m_pView->PostMessage(WM_HYBRID_MOL_PCR_PRIMER, 0);
	}
}

void MolPCRHybridDialog::OnNextHybridButton() 
{
	// Tell the view to display the next search results
	if(m_pView != NULL){
		m_pView->PostMessage(WM_HYBRID_MOL_PCR_NEXT, 0);
	}
}

void MolPCRHybridDialog::OnAnnotateHybridButton() 
{
	// Tell the view to annotation the currently selected sequence
	if(m_pView != NULL){
		m_pView->PostMessage(WM_HYBRID_MOL_PCR_ANNOTATE, 0);
	}
}
