#if !defined(AFX_MOLPCRHYBRIDDIALOG_H__46C811DF_C149_4E6C_AA47_7144AA8FA560__INCLUDED_)
#define AFX_MOLPCRHYBRIDDIALOG_H__46C811DF_C149_4E6C_AA47_7144AA8FA560__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MolPCRHybridDialog.h : header file
//

#include <string>

#define		WM_HYBRID_MOL_PCR_CLOSE		(WM_USER + 22)
#define		WM_HYBRID_MOL_PCR_PRIMER	(WM_USER + 23)
#define		WM_HYBRID_MOL_PCR_NEXT		(WM_USER + 24)
#define		WM_HYBRID_MOL_PCR_ANNOTATE	(WM_USER + 25)

/////////////////////////////////////////////////////////////////////////////
// MolPCRHybridDialog dialog

class MolPCRHybridDialog : public CDialog
{
// Construction
public:
	MolPCRHybridDialog(CView* pParent);   // standard constructor

	BOOL Create();
	BOOL OnInitDialog();

	CView *m_pView;

// Dialog Data
	//{{AFX_DATA(MolPCRHybridDialog)
	enum { IDD = IDD_MOL_HYBRID_DIALOG };
	float	m_salt;
	float	m_strand;
	float	m_tm;
	CString	m_primer1;
	CString	m_primer2;
	CString	m_results;
	UINT	m_exact_match;
	//}}AFX_DATA

	inline CString primer1_string() const
	{
		return m_primer1;
	};

	inline CString primer2_string() const
	{
		return m_primer2;
	};

	inline float tm() const
	{
		return m_tm;
	};

	inline float salt() const
	{
		return m_salt;
	};

	inline float strand() const
	{
		return m_strand;
	};

	inline unsigned int anchor() const
	{
		return m_exact_match;
	};

	inline void results_string(const std::string &m_results_string)
	{
		m_results = m_results_string.c_str();
		
		UpdateData(FALSE);
	};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MolPCRHybridDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MolPCRHybridDialog)
	afx_msg void OnCloseHybrid();
	afx_msg void OnPrimerButton();
	afx_msg void OnNextHybridButton();
	afx_msg void OnAnnotateHybridButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MOLPCRHYBRIDDIALOG_H__46C811DF_C149_4E6C_AA47_7144AA8FA560__INCLUDED_)
