// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#if !defined(AFX_OPTIONSDIALOG_H__A1599E39_9E8C_4AE8_9A36_3029C4FE2DDE__INCLUDED_)
#define AFX_OPTIONSDIALOG_H__A1599E39_9E8C_4AE8_9A36_3029C4FE2DDE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionsDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COptionsDialog dialog

class COptionsDialog : public CDialog
{
// Construction
public:
	COptionsDialog(CWnd* pParent = NULL);   // standard constructor
	BOOL OnInitDialog();

// Dialog Data
	//{{AFX_DATA(COptionsDialog)
	enum { IDD = IDD_OPTIONS_DIALOG };
	//}}AFX_DATA


	float font_res()
	{
		// High resolution is 0
		// Low resolution is 1
		return (1.0f - m_font_res/100.0f);
	};

	void font_res(const float &m_res)
	{
		// High resolution is 0
		// Low resolution is 1
		m_font_res = (UINT)(100*(1.0f - m_res));
	};

	unsigned int max_mol()
	{
		return m_max_mol;
	};

	void max_mol(const unsigned int &m_max)
	{
		m_max_mol = m_max;
	};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COptionsDialog)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONSDIALOG_H__A1599E39_9E8C_4AE8_9A36_3029C4FE2DDE__INCLUDED_)
