// PrimerDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GV.h"
#include "PrimerDialog.h"
#include "nuc_cruc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrimerDialog dialog


CPrimerDialog::CPrimerDialog(CView* pParent)
	: CDialog(CPrimerDialog::IDD, pParent)
{
	m_pView = pParent;

	//{{AFX_DATA_INIT(CPrimerDialog)
	m_option_gc_content = TRUE;
	m_max_gc = 55.0f;
	m_min_gc = 45.0f;
	m_option_multi_gc = TRUE;
	m_option_poly_gc = TRUE;
	m_option_poly_run = TRUE;
	m_tm = 50.0f;
	m_run_len = 4;
	m_option_t_3 = TRUE;
	m_primer_len = 20;
	m_salt = NC_Na;
	m_strand = NC_CT;
	m_mis_prime_tm = 10.0f;
	//}}AFX_DATA_INIT
}


void CPrimerDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrimerDialog)
	DDX_Check(pDX, IDC_GC_CHECK, m_option_gc_content);
	DDX_Text(pDX, IDC_GC_MAX_EDIT, m_max_gc);
	DDV_MinMaxFloat(pDX, m_max_gc, 0.f, 100.f);
	DDX_Text(pDX, IDC_GC_MIN_EDIT, m_min_gc);
	DDV_MinMaxFloat(pDX, m_min_gc, 0.f, 100.f);
	DDX_Check(pDX, IDC_MULTI_GC_CHECK, m_option_multi_gc);
	DDX_Check(pDX, IDC_POLY_GC_CHECK, m_option_poly_gc);
	DDX_Check(pDX, IDC_POLY_RUN_CHECK, m_option_poly_run);
	DDX_Text(pDX, IDC_PRIMER_TM_EDIT, m_tm);
	DDX_Text(pDX, IDC_RUN_EDIT, m_run_len);
	DDV_MinMaxUInt(pDX, m_run_len, 0, 100);
	DDX_Check(pDX, IDC_T_CHECK, m_option_t_3);
	DDX_Text(pDX, IDC_PRIMER_LEN_EDIT, m_primer_len);
	DDV_MinMaxUInt(pDX, m_primer_len, 10, 30);
	DDX_Text(pDX, IDC_SALT_EDIT, m_salt);
	DDX_Text(pDX, IDC_STRAND_EDIT, m_strand);
	DDX_Text(pDX, IDC_HAIRPIN_TM_EDIT, m_mis_prime_tm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPrimerDialog, CDialog)
	//{{AFX_MSG_MAP(CPrimerDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrimerDialog message handlers
BOOL CPrimerDialog::Create() 
{
	return CDialog::Create(CPrimerDialog::IDD);
}

BOOL CPrimerDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPrimerDialog::OnCancel() 
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_PRIMER_CLOSE, 0);
	}
}

void CPrimerDialog::OnOK() 
{
	UpdateData(TRUE);

	if(m_pView != NULL){
		m_pView->PostMessage(WM_PRIMER_OK, 0);
	}
}
