// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

// SearchDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GV.h"
#include "GVDoc.h"
#include "SearchDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearchDialog dialog


CSearchDialog::CSearchDialog(CView* pParent)
	: CDialog(CSearchDialog::IDD, pParent)
{
	m_pView = pParent;
	//{{AFX_DATA_INIT(CSearchDialog)
	m_key = KEY_NAME;
	m_key_string = _T("");
	m_results_string = _T("");
	//}}AFX_DATA_INIT
}


void CSearchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchDialog)
	DDX_CBIndex(pDX, IDC_KEY_COMBO, m_key);
	DDX_Text(pDX, IDC_KEY_EDIT, m_key_string);
	DDX_Text(pDX, IDC_RESULTS_EDIT, m_results_string);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearchDialog, CDialog)
	//{{AFX_MSG_MAP(CSearchDialog)
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, OnCloseButton)
	ON_BN_CLICKED(IDC_FIND_BUTTON, OnFindButton)
	ON_BN_CLICKED(IDC_FIND_NEXT_BUTTON, OnFindNextButton)
	ON_BN_CLICKED(IDC_FIND_ANNOTATE_BUTTON, OnFindAnnotateButton)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDCANCEL, OnCloseButton)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchDialog message handlers
BOOL CSearchDialog::Create() 
{
	return CDialog::Create(CSearchDialog::IDD);
}

BOOL CSearchDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSearchDialog::OnCloseButton() 
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_SEARCH_CLOSE, 0);
	}
}

void CSearchDialog::OnFindButton() 
{
	UpdateData(TRUE);

	if(m_pView != NULL){
		m_pView->PostMessage(WM_SEARCH_START, 0);
	}
}

void CSearchDialog::OnFindNextButton() 
{
	// Tell the view to display the next search results
	if(m_pView != NULL){
		m_pView->PostMessage(WM_SEARCH_NEXT, 0);
	}
}

void CSearchDialog::OnFindAnnotateButton() 
{
	// Tell the view to annotation the currently selected sequence
	if(m_pView != NULL){
		m_pView->PostMessage(WM_SEARCH_ANNOTATE, 0);
	}
}
