// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#if !defined(AFX_SEARCHDIALOG_H__2C1F87FA_54BE_40FD_87C2_3A0599A2C185__INCLUDED_)
#define AFX_SEARCHDIALOG_H__2C1F87FA_54BE_40FD_87C2_3A0599A2C185__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SearchDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSearchDialog dialog

#define		WM_SEARCH_CLOSE		(WM_USER + 2)
#define		WM_SEARCH_NEXT		(WM_USER + 3)
#define		WM_SEARCH_START		(WM_USER + 4)
#define		WM_SEARCH_ANNOTATE	(WM_USER + 19)

class CSearchDialog : public CDialog
{
// Construction
public:
	CSearchDialog(CView* pParent);
	BOOL Create();
	BOOL OnInitDialog();

	CView *m_pView;

	// Key types
	enum {KEY_NAME = 0, KEY_GI, KEY_BASE, KEY_WORD, KEY_DNA, KEY_GENOME_NAME};

	inline int key()
	{
		return m_key;
	};

	inline CString key_string()
	{
		return m_key_string;
	};

	inline void results_string(const std::string &m_results)
	{
		m_results_string = m_results.c_str();
		
		UpdateData(FALSE);
	};

// Dialog Data
	//{{AFX_DATA(CSearchDialog)
	enum { IDD = IDD_SEARCH_DIALOG };
	int		m_key;
	CString	m_key_string;
	CString	m_results_string;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSearchDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSearchDialog)
	afx_msg void OnCloseButton();
	afx_msg void OnFindButton();
	afx_msg void OnFindNextButton();
	afx_msg void OnFindAnnotateButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCHDIALOG_H__2C1F87FA_54BE_40FD_87C2_3A0599A2C185__INCLUDED_)
