// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#ifndef __DEGENERATE_NA
#define __DEGENERATE_NA

#include "sequence.h"

#include <string>
#include <list>

// M = A or C
// R = G or A
// S = G or C
// V = G or C or A
// W = A or T
// Y = T or C
// H = A or C or T
// K = G or T
// D = G or A or T
// B = G or T or C
// N = A or T or C or G

std::list<DNA3Seq> expand_nucleic_acid(const std::string &m_seq);

#endif // __DEGENERATE_NA
