// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#ifndef __GENOME_COLOR
#define __GENOME_COLOR

// Default color choices for Genomorama
// Use a 24 bit (3 byte) color space

// A macro for converting a 1 byte color channel [0...255] 
// into a float [0.0f ... 1.0f]
#define		NORMALIZE_COLOR_CHANNEL(X)		(X/255.0f)

// Yellow
#define		GV_DEFAULT_SELECT_R			(255)	
#define		GV_DEFAULT_SELECT_G			(255)
#define		GV_DEFAULT_SELECT_B			(0)

// White
#define		GV_DEFAULT_BACKGROUND_R		(255)
#define		GV_DEFAULT_BACKGROUND_G		(255)
#define		GV_DEFAULT_BACKGROUND_B		(255)

// Red
#define		GV_DEFAULT_GENE_R			(255)
#define		GV_DEFAULT_GENE_G			(0)
#define		GV_DEFAULT_GENE_B			(0)

// Pink
#define		GV_DEFAULT_PSEUDO_GENE_R	(255)
#define		GV_DEFAULT_PSEUDO_GENE_G	(0)
#define		GV_DEFAULT_PSEUDO_GENE_B	(255)

// Light Green
#define		GV_DEFAULT_CDS_R			(0)
#define		GV_DEFAULT_CDS_G			(128)
#define		GV_DEFAULT_CDS_B			(0)

// Light Blue
#define		GV_DEFAULT_ANNOT_R			(0)
#define		GV_DEFAULT_ANNOT_G			(0)
#define		GV_DEFAULT_ANNOT_B			(128)

// Orange
#define		GV_DEFAULT_PRIMER_R			(255)
#define		GV_DEFAULT_PRIMER_G			(128)
#define		GV_DEFAULT_PRIMER_B			(0)

#define		GV_DEFAULT_USER_R			(255)
#define		GV_DEFAULT_USER_G			(128)
#define		GV_DEFAULT_USER_B			(0)

// Black
#define		GV_DEFAULT_RNA_R			(0)
#define		GV_DEFAULT_RNA_G			(0)
#define		GV_DEFAULT_RNA_B			(0)

// Grey
#define		GV_DEFAULT_INTERGENIC_R		(128)
#define		GV_DEFAULT_INTERGENIC_G		(128)
#define		GV_DEFAULT_INTERGENIC_B		(128)

// Black
#define		GV_DEFAULT_TEXT_R			(0)
#define		GV_DEFAULT_TEXT_G			(0)
#define		GV_DEFAULT_TEXT_B			(0)

// Blue
#define		GV_DEFAULT_SELECT_NEG_R		(0)
#define		GV_DEFAULT_SELECT_NEG_G		(0)
#define		GV_DEFAULT_SELECT_NEG_B		(255)

// Red
#define		GV_DEFAULT_SELECT_PLUS_R	(255)
#define		GV_DEFAULT_SELECT_PLUS_G	(0)
#define		GV_DEFAULT_SELECT_PLUS_B	(0)

// Grey
#define		GV_DEFAULT_CUSTOM_R			(128)
#define		GV_DEFAULT_CUSTOM_G			(128)
#define		GV_DEFAULT_CUSTOM_B			(128)

#endif // __GENOME_COLOR
