// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#ifndef __ENTREZ_UTIL
#define	__ENTREZ_UTIL

#include <list>
#include <string>

// Enumerate the Entrex search keys
enum {ENTREZ_GENOME_ACCESSION = 0, ENTREZ_GENOME_GI, 
	  ENTREZ_GENOME_TAXA_NAME, ENTREZ_GENOME_USER_DEFINED};


// Download a list of uid's
std::list<unsigned int> gi_list_from_search_key(const std::string &m_search_key, const int &m_type);

// Download a list of (uid, descriptive string) pairs
std::list< std::pair<unsigned int, std::string> > docsum_list_from_search_key(const std::string &m_search_key, 
																		 const int &m_type);

#endif // __ENTREZ_UTIL
